/*	
 *	Pollin Electronic GmbH
 *	Max-Pollin-Strae 1			
 *	85104 Pfrring 
 *	http://www.pollin.de
 *
 *	Project:	RAPITUS SAMxS Evaluationboard 
 *  Filename:	dcf_stack.c 
 *
 *  Author:		Leonhard Hesse
 *
 *  Copyright (c) 2016 Pollin Electronic GmbH. All rights reserved.
 *
 *  Bitte beachten Sie, dass dieses Programm nur uneingeschrnkt fr nicht kommerzielle Zwecke genutzt 
 *  werden darf. Ich bernehme keine Garantie fr die einwandfreie Funktion dieses Programmes und ber- 
 *  nehme dadurch auch keine Haftung fr Folgeschden die Aufgrund der Benutzung dieser Daten entstehen. 
 *  Dieses gilt auch dann, wenn ich ber einen solchen Schaden unterrichtet worden bin. 
 */

 #include "asf.h"
 #include "dcf.h"

 /* --------------------------------------------------------------------------------------------------------------------
	Methode:		getReceivedBit:		Interpretiert und speichert bitweise die empfangenen daten
										Abhngig vom Zhlerstand des "dcf_bitCounter" werden die empfangenen Bits mit 
										Hilfe der jeweiligen Bitmaske in Variablen zwischengespeichert.
 -------------------------------------------------------------------------------------------------------------------- */

 void getReceivedBit(void)
 {
	switch (dcf_bitCounter)
	{
		/* DATA MINUTE */
		case 21:	// MIN-BIT 1
			dcf_receivedData_min &= ~(1<<DCF_BIT1_MASK);
			dcf_receivedData_min |= (dcf_detectedBit<<DCF_BIT1_MASK);
		break;
		case 22:	// MIN-BIT 2
			dcf_receivedData_min &= ~(1<<DCF_BIT2_MASK);
			dcf_receivedData_min |= (dcf_detectedBit<<DCF_BIT2_MASK);
		break;
		case 23:	// MIN-BIT 3
			dcf_receivedData_min &= ~(1<<DCF_BIT3_MASK);
			dcf_receivedData_min |= (dcf_detectedBit<<DCF_BIT3_MASK);
		break;
		case 24:	// MIN-BIT 4
			dcf_receivedData_min &= ~(1<<DCF_BIT4_MASK);
			dcf_receivedData_min |= (dcf_detectedBit<<DCF_BIT4_MASK);
		break;
		case 25:	// MIN-BIT 5
			dcf_receivedData_min &= ~(1<<DCF_BIT5_MASK);
			dcf_receivedData_min |= (dcf_detectedBit<<DCF_BIT5_MASK);
		break;
		case 26:	// MIN-BIT 6
			dcf_receivedData_min &= ~(1<<DCF_BIT6_MASK);
			dcf_receivedData_min |= (dcf_detectedBit<<DCF_BIT6_MASK);
		break;
		case 27:	// MIN-BIT 7
			dcf_receivedData_min &= ~(1<<DCF_BIT7_MASK);
			dcf_receivedData_min |= (dcf_detectedBit<<DCF_BIT7_MASK);
		break;
		case 28:	// MIN-BIT 8
			dcf_receivedData_min &= ~(1<<DCF_MIN_PARI_MASK);
			dcf_receivedData_min |= (dcf_detectedBit<<DCF_MIN_PARI_MASK);	
		break;

		/* DATA HOUR */
		case 29:	// H-BIT 1
			dcf_receivedData_h &= ~(1<<DCF_BIT1_MASK);
			dcf_receivedData_h |= (dcf_detectedBit<<DCF_BIT1_MASK);
		break;
		case 30:	// H-BIT 2
			dcf_receivedData_h &= ~(1<<DCF_BIT2_MASK);
			dcf_receivedData_h |= (dcf_detectedBit<<DCF_BIT2_MASK);
		break;
		case 31:	// H-BIT 3
			dcf_receivedData_h &= ~(1<<DCF_BIT3_MASK);
			dcf_receivedData_h |= (dcf_detectedBit<<DCF_BIT3_MASK);
		break;
		case 32:	// H-BIT 3
			dcf_receivedData_h &= ~(1<<DCF_BIT4_MASK);
			dcf_receivedData_h |= (dcf_detectedBit<<DCF_BIT4_MASK);
		break;
		case 33:	// H-BIT 4
			dcf_receivedData_h &= ~(1<<DCF_BIT5_MASK);
			dcf_receivedData_h |= (dcf_detectedBit<<DCF_BIT5_MASK);
		break;
		case 34:	// H-BIT 5
			dcf_receivedData_h &= ~(1<<DCF_BIT6_MASK);
			dcf_receivedData_h |= (dcf_detectedBit<<DCF_BIT6_MASK);
		break;
		case 35:	// H-BIT 6
			dcf_receivedData_h &= ~(1<<DCF_H_PARI_MASK);
			dcf_receivedData_h |= (dcf_detectedBit<<DCF_H_PARI_MASK);
		break;

		/* DATA DATE DAY */
		case 36:	// DAY-BIT 1
			dcf_receivedData_date_day &= ~(1<<DCF_BIT1_MASK);
			dcf_receivedData_date_day |= (dcf_detectedBit<<DCF_BIT1_MASK);
		break;
		case 37:	// DAY-BIT 2
			dcf_receivedData_date_day &= ~(1<<DCF_BIT2_MASK);
			dcf_receivedData_date_day |= (dcf_detectedBit<<DCF_BIT2_MASK);
		break;
		case 38:	// DAY-BIT 3
			dcf_receivedData_date_day &= ~(1<<DCF_BIT3_MASK);
			dcf_receivedData_date_day |= (dcf_detectedBit<<DCF_BIT3_MASK);
		break;
		case 39:	// DAY-BIT 4
			dcf_receivedData_date_day &= ~(1<<DCF_BIT4_MASK);
			dcf_receivedData_date_day |= (dcf_detectedBit<<DCF_BIT4_MASK);
		break;
		case 40:	// DAY-BIT 5
			dcf_receivedData_date_day &= ~(1<<DCF_BIT5_MASK);
			dcf_receivedData_date_day |= (dcf_detectedBit<<DCF_BIT5_MASK);
		break;
		case 41:	// DAY-BIT 6
			dcf_receivedData_date_day &= ~(1<<DCF_BIT6_MASK);
			dcf_receivedData_date_day |= (dcf_detectedBit<<DCF_BIT6_MASK);
		break;
			
		/* DATA WEEKDAY */
		case 42:	// WEEK-BIT 1
			dcf_receivedData_weekday &= ~(1<<DCF_BIT1_MASK);
			dcf_receivedData_weekday |= (dcf_detectedBit<<DCF_BIT1_MASK);
		break;
		case 43:	// WEEK-BIT 2
			dcf_receivedData_weekday &= ~(1<<DCF_BIT2_MASK);
			dcf_receivedData_weekday |= (dcf_detectedBit<<DCF_BIT2_MASK);
		break;
		case 44:	// WEEK-BIT 3
			dcf_receivedData_weekday &= ~(1<<DCF_BIT3_MASK);
			dcf_receivedData_weekday |= (dcf_detectedBit<<DCF_BIT3_MASK);
		break;
			
		/* DATA DATE MONTH */
		case 45:	// MONTH-BIT 1 
			dcf_receivedData_date_month &= ~(1<<DCF_BIT1_MASK);
			dcf_receivedData_date_month |= (dcf_detectedBit<<DCF_BIT1_MASK);
		break;
		case 46:	// MONTH-BIT 2
			dcf_receivedData_date_month &= ~(1<<DCF_BIT2_MASK);
			dcf_receivedData_date_month |= (dcf_detectedBit<<DCF_BIT2_MASK);
		break;
		case 47:	// MONTH-BIT 3
			dcf_receivedData_date_month &= ~(1<<DCF_BIT3_MASK);
			dcf_receivedData_date_month |= (dcf_detectedBit<<DCF_BIT3_MASK);
		break;
		case 48:	// MONTH-BIT 4
			dcf_receivedData_date_month &= ~(1<<DCF_BIT4_MASK);
			dcf_receivedData_date_month |= (dcf_detectedBit<<DCF_BIT4_MASK);
		break;
		case 49:	// MONTH-BIT 5
			dcf_receivedData_date_month &= ~(1<<DCF_BIT5_MASK);
			dcf_receivedData_date_month |= (dcf_detectedBit<<DCF_BIT5_MASK);
		break;

		/* DATA DATE YEAR */
		case 50:	// YEAR-BIT 1 
			dcf_receivedData_date_year &= ~(1<<DCF_BIT1_MASK);
			dcf_receivedData_date_year |= (dcf_detectedBit<<DCF_BIT1_MASK);
		break;
		case 51:	// YEAR-BIT 2
			dcf_receivedData_date_year &= ~(1<<DCF_BIT2_MASK);
			dcf_receivedData_date_year |= (dcf_detectedBit<<DCF_BIT2_MASK);
		break;
		case 52:	// YEAR-BIT 3
			dcf_receivedData_date_year &= ~(1<<DCF_BIT3_MASK);
			dcf_receivedData_date_year |= (dcf_detectedBit<<DCF_BIT3_MASK);
		break;
		case 53:	// YEAR-BIT 4
			dcf_receivedData_date_year &= ~(1<<DCF_BIT4_MASK);
			dcf_receivedData_date_year |= (dcf_detectedBit<<DCF_BIT4_MASK);
		break;
		case 54:	// YEAR-BIT 5
			dcf_receivedData_date_year &= ~(1<<DCF_BIT5_MASK);
			dcf_receivedData_date_year |= (dcf_detectedBit<<DCF_BIT5_MASK);
		break;
		case 55:	// YEAR-BIT 6
			dcf_receivedData_date_year &= ~(1<<DCF_BIT6_MASK);
			dcf_receivedData_date_year |= (dcf_detectedBit<<DCF_BIT6_MASK);
		break;
		case 56:	// YEAR-BIT 6
			dcf_receivedData_date_year &= ~(1<<DCF_BIT7_MASK);
			dcf_receivedData_date_year |= (dcf_detectedBit<<DCF_BIT7_MASK);
		break;
		case 57:	// YEAR-BIT 7
			dcf_receivedData_date_year &= ~(1<<DCF_BIT8_MASK);
			dcf_receivedData_date_year |= (dcf_detectedBit<<DCF_BIT8_MASK);
		break;
		case 58:	// YEAR-BIT 8
			dcf_receivedData_parity_date &= ~(1<<DCF_BIT1_MASK);
			dcf_receivedData_parity_date |= (dcf_detectedBit<<DCF_BIT1_MASK);
		break;
	}
	dcf_bitCounter++;
 }