/*	
 *	Pollin Electronic GmbH
 *	Max-Pollin-Strae 1			
 *	85104 Pfrring 
 *	http://www.pollin.de
 *
 *	Project:	RAPITUS SAMxS Evaluationboard 
 *  Filename:	mySpi.h 
 *
 *  Author:		Leonhard Hesse
 *
 *  Copyright (c) 2016 Pollin Electronic GmbH. All rights reserved.
 *
 *  Bitte beachten Sie, dass dieses Programm nur uneingeschrnkt fr nicht kommerzielle Zwecke genutzt 
 *  werden darf. Ich bernehme keine Garantie fr die einwandfreie Funktion dieses Programmes und ber- 
 *  nehme dadurch auch keine Haftung fr Folgeschden die Aufgrund der Benutzung dieser Daten entstehen. 
 *  Dieses gilt auch dann, wenn ich ber einen solchen Schaden unterrichtet worden bin. 
 */

#ifndef MYSPI_H_
#define MYSPI_H_

#define SPI_LAST_BYTE_TRUE		1
#define SPI_LAST_BYTE_FALSE		0

#define SPI_CS_RFM				0
#define SPI_CS_EXT				1
#define SPI_CS_ENC				3

#define SPI_PCS_RFM				0x0u
#define SPI_PCS_EXT				0x1u
#define SPI_PCS_ENC				0x7u

/* Clock polarity. */
#define SPI_CLK_POLARITY		0

/* Clock phase. */
#define SPI_CLK_PHASE			1

/* Delay before SPCK. */
#define SPI_DLYBS				0x30

/* Delay between consecutive transfers. */
#define SPI_DLYBCT				0x10
/* SPI clock setting (Hz). */
#define gs_ul_spi_clock			1000000

void mySpi_init (void);
uint8_t mySpi_rw(Spi *p_spi, uint8_t us_data, uint8_t uc_pcs, uint8_t uc_last);

#endif /* MYSPI_H_ */